; /******************************************************************************/
; /*										*/
; /*		      .		*/
; /*										*/
; /******************************************************************************/

			NAME    SYS_TIMER_DRIVER

SYS_TIMER_DRIVER	SEGMENT	CODE
SYS_TIMER_DATA		SEGMENT	DATA
SYS_TIMER_FLAG		SEGMENT	BIT

			PUBLIC  Init_Sys_Timer
			PUBLIC  _Start_Time_Out
			PUBLIC  Time_Out_End


   ;-----------------------------------------------------------------------------;
   ;         .;
SYSTEM_FREQ		EQU	24000		;    .
SYSTEM_TIMER_TICK	EQU	5		;     .
TIMER0_DIVIDER		EQU	65536-(SYSTEM_TIMER_TICK*(SYSTEM_FREQ/12))
   ;-----------------------------------------------------------------------------;


   ;-----------------------------------------------------------------------------;
   ;     0.                                             ;
			CSEG	AT	0000BH
			LJMP	Timer0_Interrupt
   ;-----------------------------------------------------------------------------;


   ;-----------------------------------------------------------------------------;
   ;   . "1" -    .            ;
			RSEG	SYS_TIMER_FLAG
Time_Out_End:		DBIT	1
   ;-----------------------------------------------------------------------------;


   ;-----------------------------------------------------------------------------;
   ;        .	 ;
			RSEG	SYS_TIMER_DATA
Sys_Timer_nTick:	DS	1
   ;-----------------------------------------------------------------------------;


   ;-----------------------------------------------------------------------------;
			RSEG	SYS_TIMER_DRIVER
			USING   0

; /******************************************************************************/
; /*										*/
; /*		       .			*/
; /*										*/
; /* void Init_Sys_Timer(void)							*/
; /* :		  .					*/
; /* :	  .					*/
; /*								       		*/
; /******************************************************************************/
Init_Sys_Timer:
	CLR	TR0			;  .
	CLR	TF0			;   .
	CLR	Time_Out_End		;    .

	ANL	TMOD,#0F0H		;  0   1.
	ORL	TMOD,#001H

	SETB	ET0			;    0 .
		  
	RET


; /******************************************************************************/
; /*										*/
; /*            0 -   .   	*/
; /*										*/
; /******************************************************************************/
Timer0_Interrupt:

   ;      .
        PUSH    PSW

   ;   .
        CLR     TR0

   ;    ?
	DJNZ	Sys_Timer_nTick,Restart_Timer0

   ;    .
   ;      .
        SETB    Time_Out_End
	SJMP	Sys_Timer_End

   ;     .
   ;   .
Restart_Timer0:
	MOV	TL0,#LOW(TIMER0_DIVIDER)
        MOV     TH0,#HIGH(TIMER0_DIVIDER)
        SETB    TR0

   ;      .
Sys_Timer_End:
        POP     PSW
        RETI    


; /******************************************************************************/
; /*										*/
; /*         .	*/
; /*										*/
; /* void Start_Time_Out(unsigned char )					*/
; /* :		     .	        */
; /* :	  .					*/
; /*										*/
; /******************************************************************************/
_Start_Time_Out:

   ;      .
	CLR	EA

   ;     .
        MOV	Sys_Timer_nTick,R7

   ;         .
	MOV	TL0,#LOW(TIMER0_DIVIDER)
        MOV     TH0,#HIGH(TIMER0_DIVIDER)

   ;     .
        CLR     Time_Out_End

   ;   .
	CLR	TF0
        SETB    TR0

   ;      .
	SETB	 EA
        RET     


; /******************************************************************************/
	END

