/********************************************************************************/
/*										*/
/*	  	     1.5.4	        */
/*			     5.1  2001 .		   		*/
/*								   		*/
/********************************************************************************/
/* 20.12.2000	-	   .			*/
/*------------------------------------------------------------------------------*/
/* 07.03.2001   -             .  */
/*------------------------------------------------------------------------------*/
/********************************************************************************/
#include "tester.h"

/*------------------------------------------------------------------------------*/
/*           -5  154.   */
/* :     .                                            */
/* :    .                                           */
/*------------------------------------------------------------------------------*/
void Connect_To_ECU(void);


/*==============================================================================*/
/*                        .			*/
/*==============================================================================*/
  /*----------------------------------------------------------------------------*/
  /* ,    ,   .		*/
  /*----------------------------------------------------------------------------*/
  idata unsigned char String[20];

/*==============================================================================*/
/*									        */
/*			     .				*/
/*										*/
/*==============================================================================*/
void main(void)
{

  /*----------------------------------------------------------------------------*/
  /*    .                                              */
  /*----------------------------------------------------------------------------*/
  enum MODE Mode=FIRST_MODE;    //     .

  /*----------------------------------------------------------------------------*/
  /*     .                                 */
  /*----------------------------------------------------------------------------*/
  enum VARIABLES Variable;

  /*----------------------------------------------------------------------------*/
  /*     .                              */
  /*----------------------------------------------------------------------------*/
  enum IO_PARAMETER ioParameter=FIRST_IO_PARAMETER;

  /*----------------------------------------------------------------------------*/
  /* 			   .			*/
  /*----------------------------------------------------------------------------*/
  /*    - .							*/
  P0=P1=P2=P3=0xff;                      

  /*   , UART,  ,  .*/
  IE=0x00;
  Init_Sys_Timer();             //   .
  Init_UART();                  //    .
  Init_Keyboard();              //   .
  Init_Beeper();                //    .
  Init_EEPROM();                //   EEPROM .
  EA=1;

  /*       50 .			*/
  Pause(50);

  /*        .           */
  Init_LCD();
  sprintf(&String, &Title_Device_Name);
  LCD_Clear(); Write_String_To_LCD(&String);
  LCD_BackLight_ON();

  /*       0.5 				*/
  Sound_ON(); Pause(500); Sound_OFF();

  /*   1      .		        */
  Pause(1000);
  sprintf(&String, &Title_Version_Number);
  LCD_Clear(); Write_String_To_LCD(&String);

  /*      1,2 .                                    */
  Pause(1200);

  /*       EEPROM .                */
  Variable=Read_Variable();

  /*----------------------------------------------------------------------------*/
  /* 			       .				*/
  /*----------------------------------------------------------------------------*/
  for(;;)
     {
       /*=======================================================================*/
       /*                                                                       */
       /*                   .               */
       /*                                                                       */
       /*=======================================================================*/
       if(Mode == VARIABLES_MODE)
         {
           /*    .                        */
           /* =0 -   , =1 -   .*/
           bit UpDownList=UP;

           /*           .  */
           /*       "".                      */
           while(is_Mode_Key_Not_Pressed())
             {
               /*---------------------------------------------------------------*/
               /*	      120 .	        */
               /*---------------------------------------------------------------*/
               Pause(120);
               Sound_OFF();             //  .

               /*---------------------------------------------------------------*/
               /*      readDataByLocalIndentifier.    */
               /*---------------------------------------------------------------*/
               //      -  .
               if(Read_After_Sales_Service_Data() != OK) Connect_To_ECU();
               else
                 {
                   /*-----------------------------------------------------------*/
                   /*          */
                   /*           .    */
                   /*-----------------------------------------------------------*/
                   switch(Variable)
                     {
                       /*-------------------------------------------------------*/
                       case PASP:
                         {
                           //    .
                           Pause(120);
                           if(Read_Vehicle_Manufacturer_ECU_Identifier() != OK) { Connect_To_ECU(); break; }

                           //    .
                           Message[10]=0x00;
                           sprintf(&String, &Title_PASP, &Message[2]);
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case THR:
                         {
                           //      .
                           sprintf(&String, &Title_THR, Get_THR());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case TWAT:
                         {
                           //     .
                           signed char Byte=Get_TWAT();

                           //      .
                           sprintf(&String, &Title_TWAT, Byte);
                           LCD_Clear(); Write_String_To_LCD(&String);

		           //    110  - .
		           if(Byte >= 110) Sound_ON();

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case FREQ:
                         {
                           //    .
                           //   2550    10,  - 40.
                           unsigned int Word=Get_FREQ();
			   if(Word < 2550) Word=Get_FREQX();

                           //      .
                           sprintf(&String, &Title_FREQ, Word);
                           LCD_Clear(); Write_String_To_LCD(&String);

		           //    5550 - .
		           if(Word > 5500) Sound_ON();

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JUFRXX:
                         {
                           //      .
                           sprintf(&String, &Title_JUFRXX, Get_JUFRXX());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case UOZ:
                         {
                           //      .
                           sprintf(&String, &Title_UOZ, Get_UOZ());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JSPEED:
                         {
                           //      .
                           sprintf(&String, &Title_JSPEED, Get_JSPEED());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case FSM:
                         {
                           //      .
                           sprintf(&String, &Title_FSM, Get_FSM());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case SSM:
                         {
                           //      .
                           sprintf(&String, &Title_SSM, Get_SSM());
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JAUACC:
                         {
                           //      .
                           unsigned int Word=Get_JAUACC();
                           sprintf(&String, &Title_JAUACC, (unsigned char)(Word/100), (unsigned char)(Word%100));
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //    10   15 - .
                           if((Word <= 1000) || (Word >= 1500)) Sound_ON();

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case RCO:
                         {
                           //   CO  
                           //     .
                           if(is_Lambda_Present())
                             {
                               //    .
                               //   .
                               if(UpDownList == DOWN) Variable--;
                               else Variable++;
                             }
                           else
                             {
                               //     .
                               //      CO.
                               if((signed char)Message[11] < 0)
                                 {
                                   unsigned int Word=(((unsigned int)(-Message[11]))*1000)>>8;
                                   sprintf(&String, &Title_RCO, '-', Word);
                                 }
                               else
                                 {
                                   unsigned int Word=(((unsigned int)Message[11])*1000)>>8;
                                   sprintf(&String, &Title_RCO, '+', Word);
                                 } 
                               LCD_Clear(); Write_String_To_LCD(&String);
                             }

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case VALF:
                         {
                           //  /  
                           //     .
                           if(is_Lambda_Present())
                             {
                               //    .
                               //     /.
			       unsigned int Word=Get_VALF();
			       sprintf(&String, &Title_VALF, (unsigned char)(Word/100), (unsigned char)(Word%100));
                               LCD_Clear(); Write_String_To_LCD(&String);
                             }
                           else
                             {
                               //     .
                               //   .
                               if(UpDownList == DOWN) Variable--;
                               else Variable++;
                             }

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case COEFFF:
                         {
                           //    .  .
                           unsigned int Word=Get_COEFFF();
		           sprintf(&String, &Title_COEFFF, (unsigned char)(Word/100), (unsigned char)(Word%100));
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JALAM:
                         {
                           //     
                           //      .
                           if(is_Lambda_Present())
                             {
                               //    .
                               //      .
                               unsigned char Byte=Get_JALAM();
			       sprintf(&String, &Title_JALAM, (unsigned char)(Byte/100), (unsigned char)(Byte%100));
                               LCD_Clear(); Write_String_To_LCD(&String);
                             }
                           else
                             {
                               //     .
                               //   .
                               if(UpDownList == DOWN) Variable--;
                               else Variable++;
                             }

                           break;
                         }

                       /*-------------------------------------------------------*/
                       case INJ:
                         {
                           //      .
                           unsigned int Word;
                           if(is_Lambda_Present())
                             Word=((((unsigned int)Message[25]<<8)|Message[24])*10)>>7;
                           else
                             Word=((((unsigned int)Message[23]<<8)|Message[22])*10)>>7;
		           sprintf(&String, &Title_INJ, (unsigned char)(Word/10), (unsigned char)(Word%10));
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JGBC:
                         {
                           //      .
                           unsigned int Word;
                           if(is_Lambda_Present())
                             Word=(((unsigned int)Message[29]<<8)|Message[28])/6;
                           else
                             Word=(((unsigned int)Message[27]<<8)|Message[26])/6;
		           sprintf(&String, &Title_JGBC, Word);
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JAIR:
                         {
                           //      .
                           unsigned int Word;
                           if(is_Lambda_Present())
		             Word=((unsigned int)Message[27]<<8)|Message[26];
                           else
		             Word=((unsigned int)Message[25]<<8)|Message[24];
			   sprintf(&String, &Title_JAIR, (unsigned char)(Word/10),(unsigned char)(Word%10));
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JQT:
                         {
                           //      .
                           unsigned int Word;
                           if(is_Lambda_Present())
                             Word=(((unsigned int)Message[31]<<8)|Message[30])/5;
                           else
                             Word=(((unsigned int)Message[29]<<8)|Message[28])/5;
		           sprintf(&String, &Title_JQT, (unsigned char)(Word/10),(unsigned char)(Word%10));
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case JQD:
                         {
                           //      .
                           unsigned char Byte;
                           if(is_Lambda_Present())
                             Byte=(((unsigned int)Message[33]<<8)|Message[32])>>7;
                           else
                             Byte=(((unsigned int)Message[31]<<8)|Message[30])>>7;

                           //   40/100  .
			   if(Byte < 40)
                             sprintf(&String, &Title_JQD, Byte);
                           else
                             sprintf(&String, &Title_Non_JQD);
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case DET:
                         {
                           //      .
                           if(is_Detonation_Present())
                             {
                               sprintf(&String,&Title_DET,&Title_YES);
                               Sound_ON();     //  .
                             }
                           else
                             {
                               sprintf(&String,&Title_DET,&Title_NO);
                             }
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case BLKINJ:
                         {
                           //      .
                           if(is_Injector_Blocking())
                             {
                               sprintf(&String,&Title_BLKINJ,&Title_YES);
                               Sound_ON();     //  .
                             }
                           else
                             {
                               sprintf(&String,&Title_BLKINJ,&Title_NO);
                             }
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case RXX:
                         {
                           //      .
                           if(is_Idle_Step())
                             sprintf(&String,&Title_RXX,&Title_YES);
                           else
                             sprintf(&String,&Title_RXX,&Title_NO);
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       case BITPOW:
                         {
                           //      .
                           if(is_Power_Mode())
                             {
                               sprintf(&String,&Title_BITPOW,&Title_YES);
                               Sound_ON();
                             }
                           else
                             {
                               sprintf(&String,&Title_BITPOW,&Title_NO);
                             }
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       default:
                         {
			   //     -    1.
                           Variable=FIRST_VARIABLE;

                           //     .
                           Save_Variable(Variable);
                         }
                     }          // switch  .
                 }              //   .

               /*---------------------------------------------------------------*/
               /*        . .    */
               /*---------------------------------------------------------------*/
               /*   ""    .		*/
               if(is_Left_Key_Pressed())
                 {
                   /*    "".			        */
                   Reset_Left_Key_State();

                   /*      .          */
		   if(Variable-- == FIRST_VARIABLE) Variable=LAST_VARIABLE;

                   /*     .       */
                   UpDownList=DOWN;

		   /*     .          */
	           Sound_ON();
                 }

               /*---------------------------------------------------------------*/
               /*   ""    .		*/
               if(is_Right_Key_Pressed())
                 {
                   /*    "".			*/
                   Reset_Right_Key_State();

                   /*      .          */
		   if(Variable++ == LAST_VARIABLE) Variable=FIRST_VARIABLE;

                   /*     .       */
                   UpDownList=UP;

		   /*     .          */
	           Sound_ON();
                 }

               /*---------------------------------------------------------------*/
               /*    ""   .	*/
               if(is_Enter_Key_Long_Pressed())
                 {
                   /*    "".			        */
                   Reset_Enter_Key_State();

                   /*      -  .  */
                   if(Read_Variable() != Variable) Save_Variable(Variable);

		   /*    .                  */
	           Sound_ON();
                 }
             }         //      .

           /*-------------------------------------------------------------------*/
           /*     "".                             */
           /*    .	                                */
           /*-------------------------------------------------------------------*/
           /*    "".			                */
           Reset_Mode_Key_State();

           /*   .                                              */
           if(Mode++ == LAST_MODE) Mode=FIRST_MODE;

           /*    .                                   */
           Sound_ON();
           continue;    //      .
         }              //     .

       /*=======================================================================*/
       /*                                                                       */
       /*                    .               */
       /*                                                                       */
       /*=======================================================================*/
       if(Mode == TROUBLES_CODE_MODE)
         {
           unsigned char CurError=0;      //    .

           /*-------------------------------------------------------------------*/
           /*           .    */
           /*-------------------------------------------------------------------*/
           /*       "".                      */
           while(is_Mode_Key_Not_Pressed())
             {
               /*      120 .	                */
               Pause(120);
               Sound_OFF();            //  .

               /*      .            */
               /*      -  .                 */
               if(Read_Diagnostic_Trouble_Codes() != OK) Connect_To_ECU();
               else
                 {
                   /*     .                       */
                   /*     .                            */
                   sprintf(&String, &Title_ERRORS, nErrors());
                   LCD_Clear(); Write_String_To_LCD(&String);

                   /*    -     .      */
                   if((nErrors() != 0) && (is_Left_Key_Pressed() ||
                       is_Right_Key_Pressed() || is_Enter_Key_Pressed())) break;
                 }
             }          //     .

           /*-------------------------------------------------------------------*/
           /*      .              */
           /*-------------------------------------------------------------------*/
           /*       "" -  ,       */
           /*     "" -   . */
           while(is_Mode_Key_Not_Pressed() && is_Enter_Key_Not_Long_Pressed())
             {
               /*---------------------------------------------------------------*/
               /*      120 .	                */
               Pause(120);
               Sound_OFF();            //  .

               /*---------------------------------------------------------------*/
               /*      .                 */
               sprintf(&String, &Title_CUR_ERROR, CurError,
                        Message[2+CurError*3], Message[3+CurError*3]);
               LCD_Clear(); Write_String_To_LCD(&String);

               /*---------------------------------------------------------------*/
               /*   ""    .		*/
               if(is_Left_Key_Pressed())
                 {
                   /*    "".			        */
                   Reset_Left_Key_State();

                   /*      .              */
		   if(CurError-- == 0) CurError=nErrors()-1;

		   /*     .       */
	           Sound_ON();
                 }

               /*---------------------------------------------------------------*/
               /*   ""    .		*/
               if(is_Right_Key_Pressed())
                 {
                   /*    "".			*/
                   Reset_Right_Key_State();

                   /*      .              */
		   if(CurError++ >= (nErrors()-1)) CurError=0;

		   /*     .       */
	           Sound_ON();
                 }
             }          //     .

           /*-------------------------------------------------------------------*/
           /*       .*/
           /*-------------------------------------------------------------------*/
           if(is_Mode_Key_Pressed())
             {
               /*     "".                         */
               /*    .	                        */
               /*    "".			        */
               Reset_Mode_Key_State();

               /*   .                                          */
               if(Mode++ == LAST_MODE) Mode=FIRST_MODE;
             }
           else
             {
               /*       "".            */
               /*    ""   .     */
               /*       .             */
               while(is_Enter_Key_Long_Pressed())
                 {
                   /*      120 .      */
                   Pause(120);

                   /*      .          */
                   /*      -  .             */
                   if(Clear_Diagnostic_Information() != OK) Connect_To_ECU();
                   else
                     {
                       /*   .                           */
                       break;
                     }
                 }      //    .
             }

           Sound_ON();  //     .
           continue;    //      .
         }              //      .

       /*=======================================================================*/
       /*                                                                       */
       /*                 .         */
       /*                                                                       */
       /*=======================================================================*/
       if(Mode == IO_CONTROL_MODE)
         {
           /*     .         */
           /* =0 -   , =1 -   .                */
           bit UpDownList=UP;

           /*           .    */
           /*       "".                      */
           while(is_Mode_Key_Not_Pressed())
             {
               /*---------------------------------------------------------------*/
               /*	      130 .	        */
               /*---------------------------------------------------------------*/
	       Pause(130);
               Sound_OFF();             //  .

               /*---------------------------------------------------------------*/
               /*            .          */
               /*---------------------------------------------------------------*/
               switch(ioParameter)
                 {
                   /*-----------------------------------------------------------*/
                   case CHECK_ENGINE:
                     {
                       /*-------------------------------------------------------*/
                       /*     Check Engine.      */
                       /*-------------------------------------------------------*/
                       if(Get_CE_Lamp_State() != OK) { Connect_To_ECU(); break; }
                       if(is_CE_Lamp_ON())
                         sprintf(&String, &Title_CHECK_ENGINE, &Title_YES);
                       else
                         sprintf(&String, &Title_CHECK_ENGINE, &Title_NO);
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //       Check Engine.
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                       	   Pause(120);
                           Sound_OFF();         //  .

                           //     Check Engine.
                           if(Get_CE_Lamp_State() != OK) { Connect_To_ECU(); continue; }
                           if(is_CE_Lamp_ON())
                             sprintf(&String+1, &Title_CHECK_ENGINE, &Title_YES);
                           else
                             sprintf(&String+1, &Title_CHECK_ENGINE, &Title_NO);
                           String[0]='*';       //    .
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""   Check Engine.
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //   Check Engine.
                               Pause(120); Set_CE_Lamp_OFF();

      		               //     .
                               Sound_ON();
                               continue;
                             }

                           //   ""   Check Engine.
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //   Check Engine.
	                       Pause(120); Set_CE_Lamp_ON();

                               //     .
	                       Sound_ON();
                               continue;
                             }
                         }              //    Check Engine.

                       //    Check Engine .
                       Reset_Enter_Key_State();

                       //    Check Engine .    
                       while(Return_Control_CE_Lamp_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }                  // case CHECK_ENGINE.

                   /*-----------------------------------------------------------*/
                   case COOLING_FAN_RELAY:
                     {
                       /*-------------------------------------------------------*/
                       /*     .  */
                       /*-------------------------------------------------------*/
                       if(Get_Cooling_Fan_State() != OK) { Connect_To_ECU(); break; }
                       if(is_Cooling_Fan_ON())
                         sprintf(&String, &Title_ENGINE_COOLER, &Title_YES);
                       else
                         sprintf(&String, &Title_ENGINE_COOLER, &Title_NO);
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //      .
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                       	   Pause(120);
                           Sound_OFF();             //  .

                           //    .
                           if(Get_Cooling_Fan_State() != OK) { Connect_To_ECU(); continue; }
                           if(is_Cooling_Fan_ON())
                             sprintf(&String+1, &Title_ENGINE_COOLER, &Title_YES);
                           else
                             sprintf(&String+1, &Title_ENGINE_COOLER, &Title_NO);
                           String[0]='*';       //    .
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""  .
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //    .
	                       Pause(120); Set_Cooling_Fan_OFF();

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //   ""  .
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //    .
	                       Pause(120); Set_Cooling_Fan_ON();

		               //     .
	                       Sound_ON();
                               continue;
                             }
                         }              //     .

                       //    .
                       Reset_Enter_Key_State();

                       //    .
                       while(Return_Control_Cooling_Fan_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }                  // case COOLING_FAN_RELAY.

                   /*-----------------------------------------------------------*/
                   case FUEL_PUMP_RELAY:
                     {
                       /*-------------------------------------------------------*/
                       /*    -   .   */
                       /*-------------------------------------------------------*/
                       if(Read_After_Sales_Service_Data() != OK) { Connect_To_ECU(); break; }
                       if(is_Engine_ON())
                         {
                           sprintf(&String, &Title_FUEL_PUMP, "--");
                           LCD_Clear(); Write_String_To_LCD(&String);
                           break;
                         }

                       /*-------------------------------------------------------*/
                       /*    .             */
                       /*-------------------------------------------------------*/
               	       Pause(120);
                       if(Get_Fuel_Pump_State() != OK) { Connect_To_ECU(); break; }
                       if(is_Fuel_Pump_ON())
                          sprintf(&String, &Title_FUEL_PUMP, &Title_YES);
                       else
                          sprintf(&String, &Title_FUEL_PUMP, &Title_NO);
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //      .
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                       	   Pause(120);
                           Sound_OFF();             //  .

                           //    .
                           //    -   .
                           if(Read_After_Sales_Service_Data() != OK) { Connect_To_ECU(); continue; }
                           if(is_Engine_ON()) break;

                           //  .
                           //    .
                       	   Pause(120);
                           if(Get_Fuel_Pump_State() != OK) { Connect_To_ECU(); continue; }
                           if(is_Fuel_Pump_ON())
                             sprintf(&String+1, &Title_FUEL_PUMP, &Title_YES);
                           else
                             sprintf(&String+1, &Title_FUEL_PUMP, &Title_NO);
                           String[0]='*';       //    .
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""  .
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //  .
	                       Pause(120); Set_Fuel_Pump_OFF();

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //   ""  .
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //  .
                               Pause(120); Set_Fuel_Pump_ON();

		               //     .
	                       Sound_ON();
                               continue;
                             }
                         }              //   .

                       //     
                       //   "",   .
                       if(is_Enter_Key_Not_Pressed()) break;

                       //     .
                       //    .
                       Reset_Enter_Key_State();
                       while(Return_Control_Fuel_Pump_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }                  // case FUEL_PUMP_RELAY

                   /*-----------------------------------------------------------*/
                   case IGNITION_1:
                   case IGNITION_2:
                     {
                       /*-------------------------------------------------------*/
                       /*     .        */
                       /*-------------------------------------------------------*/
                       unsigned char Ignition=(unsigned char)(ioParameter-IGNITION_1);

                       /*-------------------------------------------------------*/
                       /*     .                         */
                       /*-------------------------------------------------------*/
                       if(Tester_Present() != OK) { Connect_To_ECU(); break; }

                       /*-------------------------------------------------------*/
                       /*   "[n].                        */
                       /*-------------------------------------------------------*/
                       sprintf(&String, &Title_IGNITION, Ignition+1, "\0");
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""  .          */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .  .
                       Reset_Enter_Key_State();

                       //    .
                       Pause(120);      //   Tester_Present.
                       if(Set_Ignition_ON(Ignition) != OK) break;

                       //     
                       //      .
                       sprintf(&String, &Title_IGNITION, Ignition+1, "***");
                       LCD_Clear(); Write_String_To_LCD(&String);
                       Sound_ON();              //   .
                       break;
                     }                  // case IGNITION_1
                                        // case IGNITION_2

                   /*-----------------------------------------------------------*/
                   case INJECTOR_1:
                   case INJECTOR_2:
                   case INJECTOR_3:
                   case INJECTOR_4:
                     {
                       /*-------------------------------------------------------*/
                       /*    .                 */
                       /*-------------------------------------------------------*/
                       unsigned char Injector=(unsigned char)(ioParameter-INJECTOR_1);

                       /*-------------------------------------------------------*/
                       /*     .                         */
                       /*-------------------------------------------------------*/
                       if(Tester_Present() != OK) { Connect_To_ECU(); break; }

                       /*-------------------------------------------------------*/
                       /*   "[n].                       */
                       /*-------------------------------------------------------*/
                       sprintf(&String, &Title_INJECTOR, Injector+1, "\0");
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""  .         */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .  .
                       Reset_Enter_Key_State();

                       //    .
                       Pause(120);      //   Tester_Present.
                       if(Set_Injector_ON(Injector) != OK) break;

                       //     
                       //      .
                       sprintf(&String, &Title_INJECTOR, Injector+1, "***");
                       LCD_Clear(); Write_String_To_LCD(&String);
                       Sound_ON();              //   .
                       break;
                     }                  // case INJECTOR_1
                                        // case INJECTOR_2
                                        // case INJECTOR_3
                                        // case INJECTOR_4

                   /*-----------------------------------------------------------*/
                   case CO_TRIMMING:
                     {
                       /*      . */
                       if(Read_After_Sales_Service_Data() != OK) { Connect_To_ECU(); break; }
                       if(is_Lambda_Present())
                         {
                           //    .
                           //     .
                           if(UpDownList == DOWN) ioParameter--;
                           else ioParameter++;
                           break;
                         }

                       /*-------------------------------------------------------*/
                       /*     .           */
                       /*      .*/
                       /*-------------------------------------------------------*/
               	       Pause(120);
                       if(Get_CO_Trimmer_State() != OK) { Connect_To_ECU(); break; }
                       if((signed char)Message[3] < 0)
                         {
                           unsigned int Word=(((unsigned int)(-Message[3]))*1000)>>8;
                           sprintf(&String, &Title_RCO, '-', Word);
                         }
                       else
                         {
                           unsigned int Word=(((unsigned int)Message[3])*1000)>>8;
                           sprintf(&String, &Title_RCO, '+', Word);
                         } 
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //      .  .
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                       	   Pause(120);
                           Sound_OFF();             //  .

                           //    .  CO.
                           if(Get_CO_Trimmer_State() != OK) { Connect_To_ECU(); continue; }
                           if((signed char)Message[3] < 0)
                             {
                               unsigned int Word=(((unsigned int)(-Message[3]))*1000)>>8;
                               sprintf(&String+1, &Title_RCO, '-', Word);
                             }
                           else
                             {
                               unsigned int Word=(((unsigned int)Message[3])*1000)>>8;
                               sprintf(&String+1, &Title_RCO, '+', Word);
                             } 
                           String[0]='*';       //    CO.
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""  .  CO.
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //    CO.
	                       Pause(120); Set_RCO_Value(Message[3]-1);

          		       //    .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           // .  CO  5 .
                           if(is_Left_Key_Long_Pressed())
                             {
                               //   5   CO.
                               Pause(120); Set_RCO_Value(Message[3]-5);

          		       //    .
	                       Sound_ON();
                               continue;
                             }

                           //   ""  .  CO.
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //    CO.
                               Pause(120); Set_RCO_Value(Message[3]+1);

		               //    .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           // .  CO  5 .
                           if(is_Right_Key_Long_Pressed())
                             {
                               //   5   CO.
                               Pause(120); Set_RCO_Value(Message[3]+5);

          		       //    .
	                       Sound_ON();
                               continue;
                             }
                         }              //   CO.

                       //   CO .
                       Reset_Enter_Key_State();

                       //   .   .
                       while(Return_Control_CO_Trimmer_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }                  // case CO_TRIMMING

                   /*-----------------------------------------------------------*/
                   case IDLE_ENGINE_SPEED:
                     {
                       /*-------------------------------------------------------*/
                       /*     .              */
                       /*-------------------------------------------------------*/
                       if(Get_Idle_Engine_Speed() != OK) { Connect_To_ECU(); break; }
                       sprintf(&String, &Title_FREQX, (unsigned int)(Message[5]*10));
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //       .
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                       	   Pause(120);
                           Sound_OFF();             //  .

                           //     .
                           if(Get_Idle_Engine_Speed() != OK) { Connect_To_ECU(); continue; }
                           sprintf(&String+1, &Title_FREQX, (unsigned int)(Message[5]*10));
                           String[0]='*';       //     .
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""   .
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //   .
                               if(Message[6] != 0) Message[6]--;
                               Pause(120); Set_Idle_Engine_Speed(Message[6]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           //    50 /.
                           if(is_Left_Key_Long_Pressed())
                             {
                               //   50  .
                               if(Message[6] >= 10) Message[6]-=5;
                               Pause(120); Set_Idle_Engine_Speed(Message[6]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //   ""   .
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //   .
                               if(Message[6] != 255) Message[6]++;
                               Pause(120); Set_Idle_Engine_Speed(Message[6]);

		               //     .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           //    50 /.
                           if(is_Right_Key_Long_Pressed())
                             {
                               //   50  .
                               if(Message[6] <= 245) Message[6]+=5;
                               Pause(120); Set_Idle_Engine_Speed(Message[6]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }
                         }              //    .

                       //     .
                       Reset_Enter_Key_State();

                       //     .
                       while(Return_Control_Idle_Engine_Speed_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }

                   /*-----------------------------------------------------------*/
                   case IDLE_STEP_MOTOR:
                     {
                       /*-------------------------------------------------------*/
                       /*     .           */
                       /*-------------------------------------------------------*/
                       if(Get_Idle_Step_Motor_Position() != OK) { Connect_To_ECU(); break; }
                       sprintf(&String, &Title_FSM,Message[4]);
                       LCD_Clear(); Write_String_To_LCD(&String);

                       /*-------------------------------------------------------*/
                       /*    ""    .  */
                       /*-------------------------------------------------------*/
                       if(is_Enter_Key_Not_Pressed()) break;

                       //  "" .
                       //       .
                       Sound_ON();
                       Reset_Enter_Key_State();
                       while(is_Enter_Key_Not_Pressed())
                         {
                           //    - 120 .
                           Pause(120);
                           Sound_OFF();             //  .

                           //     .
                           if(Get_Idle_Step_Motor_Position() != OK) { Connect_To_ECU(); continue; }
                           sprintf(&String+1, &Title_FSM, Message[4]);
                           String[0]='*';       //    .
                           LCD_Clear(); Write_String_To_LCD(&String);

                           //   ""   .
                           if(is_Left_Key_Pressed())
                             {
                               //    "".
                               Reset_Left_Key_State();

                               //   .
                               if(Message[4] != 0) Message[4]--;
                               Pause(120); Set_Idle_Step_Motor_Position(Message[4]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           //    5 .
                           if(is_Left_Key_Long_Pressed())
                             {
                               //   5   .
                               if(Message[4] >= 10) Message[4]-=5;
                               Pause(120); Set_Idle_Step_Motor_Position(Message[4]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }

                           //   ""   .
                           if(is_Right_Key_Pressed())
                             {
                               //    "".
                               Reset_Right_Key_State();

                               //   .
                               if(Message[4] != 255) Message[4]++;
                               Pause(120); Set_Idle_Step_Motor_Position(Message[4]);

		               //     .
	                       Sound_ON();
                               continue;
                             }

                           //    "" 
                           //    5 .
                           if(is_Right_Key_Long_Pressed())
                             {
                               //   5  .
                               if(Message[4] <= 245) Message[4]+=5;
                               Pause(120); Set_Idle_Step_Motor_Position(Message[4]);

          		       //     .
	                       Sound_ON();
                               continue;
                             }
                         }              //    .

                       //     .
                       Reset_Enter_Key_State();

                       //     .
                       while(Return_Control_Idle_Step_Motor_To_ECU() != OK)
                         {
                           Connect_To_ECU(); Pause(120);
                         }
                       Sound_ON();
                       break;
                     }

                   /*-----------------------------------------------------------*/
                   default:
                     {
		       //     -    1.
                       ioParameter=FIRST_IO_PARAMETER;
                     }
                 }         // switch   .

               /*---------------------------------------------------------------*/
               /*        . .    */
               /*---------------------------------------------------------------*/
               /*   ""    .		        */
               if(is_Left_Key_Pressed())
                 {
                   /*    "".			        */
                   Reset_Left_Key_State();

                   /*    .                            */
		   if(ioParameter-- == FIRST_IO_PARAMETER) ioParameter=LAST_IO_PARAMETER;

                   /*     .               */
                   UpDownList=DOWN;

		   /*     .                 */
	           Sound_ON();
                 }

               /*---------------------------------------------------------------*/
               /*   ""    .		        */
               if(is_Right_Key_Pressed())
                 {
                   /*    "".			*/
                   Reset_Right_Key_State();

                   /*    .                            */
		   if(ioParameter++ == LAST_IO_PARAMETER) ioParameter=FIRST_IO_PARAMETER;

                   /*     .               */
                   UpDownList=UP;

		   /*     .                 */
	           Sound_ON();
                 }
             }             //   .

           /*-------------------------------------------------------------------*/
           /*     "".                             */
           /*    .	                                */
           /*-------------------------------------------------------------------*/
           /*    "".			                */
           Reset_Mode_Key_State();

           /*   .                                              */
           if(Mode++ == LAST_MODE) Mode=FIRST_MODE;

           /*    .                                   */
           Sound_ON();
           continue;    //      .
         }              //     .

       /*=======================================================================*/
     }			//   .
  return;
}                       //   .


/*------------------------------------------------------------------------------*/
/*           -5  154.   */
/*   5     ,     -     */
/*     " ".   ,         */
/*     M1  J5,     "  ". */
/* :     .                                            */
/* :    .                                           */
/*------------------------------------------------------------------------------*/
void Connect_To_ECU(void)
{
  /*      .                                  */
  /*  5      " ".      */
  register unsigned char nReConnect;

  /*           .       */
  for(nReConnect=5; nReConnect!=0; nReConnect--)
     {
       //     testerPresent.
       Pause(120);
       if(Tester_Present() == OK)
         {
           //    testerPresent.
           //      .
           Pause(120);
           if(Read_Vehicle_Manufacturer_ECU_Identifier() == OK)
             {
               /*      M1  J5.				*/
               if(((Message[2] == 'M') && (Message[3] == '1')) ||
	          ((Message[2] == 'J') && (Message[3] == '5')))
	           {
		     /*    .				*/
		     /*     .				*/
                     break;
		   }
	       else
                   {
		     /*     ( 1.5.4   -5).	*/
		     /*   "  ".			*/
	             sprintf(&String, &Title_Error_ECU_Type);
		     LCD_Clear(); Write_String_To_LCD(&String);
	             continue;
		   }
             }
         }

       //     testerPresent.
       //     startCommunucation.
       Pause(120);
       if(Start_Communication() == OK) break;
     }

  /*  5   ,   " ".      */
  if(nReConnect == 0)
    {
      sprintf(&String, &Title_Not_Connect);
      LCD_Clear(); Write_String_To_LCD(&String);
    }

  return;
}

