/********************************************************************************/
/*										*/
/*	        " 1.5.4"		*/
/*										*/
/********************************************************************************/
#ifndef _TESTER_H
#define _TESTER_H

#include "s8252.h"
#include "lcd\lcd.h"            //  .
#include "timer\timer.h"        //   .
#include "uart\uart.h"          //   .
#include "keyboard\keyboard.h"  //  .
#include "keyword\keyword.h"    //   KEYWORD2000.
#include "beeper\beeper.h"      //   .
#include "messages\messages.h"  //     .
#include "eeprom\eeprom.h"      //  EEPROM .
#include <stdio.h>              //   spintf().

/*------------------------------------------------------------------------------*/
/*    "".                                        */
/*------------------------------------------------------------------------------*/
enum MODE
    {
      VARIABLES_MODE     = 0,   //     .
      TROUBLES_CODE_MODE = 1,   //      .
      IO_CONTROL_MODE    = 2    //    .
    };

#define FIRST_MODE  VARIABLES_MODE
#define LAST_MODE   IO_CONTROL_MODE

/*------------------------------------------------------------------------------*/
/*   "" .                              */
/*------------------------------------------------------------------------------*/
enum VARIABLES
    {
      PASP    = 0,              //   .
      THR     = 1,              //   .
      TWAT    = 2,              //   .
      FREQ    = 3,              //  .
      JUFRXX  = 4,              //   ..
      UOZ     = 5,              //   .
      JSPEED  = 6,              //   .
      FSM     = 7,              //    ..
      SSM     = 8,              //    ..
      JAUACC  = 9,              //   .      
      RCO     = 10,             //   .
      VALF    = 11,             //  /.
      COEFFF  = 12,             //    .
      JALAM   = 13,             //    .
      INJ     = 14,             //   .
      JGBC    = 15,             //   .
      JAIR    = 16,             //   .
      JQT     = 17,             //   .
      JQD     = 18,             //   .
      DET     = 19,             //   .
      BLKINJ  = 20,             //    .
      RXX     = 21,             //   .
      BITPOW  = 22              //    .
    };

#define FIRST_VARIABLE  PASP
#define LAST_VARIABLE   BITPOW

/*--------------------------------------------------------------------------*/
/*   ""  .            */
/*--------------------------------------------------------------------------*/
enum IO_PARAMETER
    {
      CHECK_ENGINE      = 0,    //  Check Engine.
      COOLING_FAN_RELAY = 1,    //     .
      FUEL_PUMP_RELAY   = 2,    //   .
      IGNITION_1        = 3,    //   1.
      IGNITION_2        = 4,    //   2.
      INJECTOR_1        = 5,    //  1.
      INJECTOR_2        = 6,    //  2.
      INJECTOR_3        = 7,    //  3.
      INJECTOR_4        = 8,    //  4.
      CO_TRIMMING       = 9,    //   .
      IDLE_ENGINE_SPEED = 10,   //   .
      IDLE_STEP_MOTOR   = 11    //   .
    };

#define FIRST_IO_PARAMETER  CHECK_ENGINE
#define LAST_IO_PARAMETER   IDLE_STEP_MOTOR

/*------------------------------------------------------------------------------*/
/*      .               */
/*------------------------------------------------------------------------------*/
#define UP      1
#define DOWN    0



/********************************************************************************/
#endif

